require "import"
import "android.media.MediaPlayer"

-- Función para obtener la ruta de los archivos de sonido
function get_file_path(filename)
  local paths = {
    "/storage/emulated/0/解说/Plugins/" .. filename,
    "/storage/emulated/0/解说/Complementos/" .. filename
  }
  
  for _, path in ipairs(paths) do
    if file_exists(path) then
      return path
    end
  end
  
  return nil
end

-- Función para verificar si un archivo existe
function file_exists(path)
  local file = io.open(path, "r")
  if file then
    io.close(file)
    return true
  else
    return false
  end
end

files_efectos = {
  "audio recorder con sonidos/VideoRecord.ogg",
"audio recorder con sonidos/VideoStop.ogg"
}

function stop_global_mp_efectos()
  if global_mp_efectos ~= nil then
    global_mp_efectos.stop()
    global_mp_efectos.release()
    global_mp_efectos = nil
  end
end

function play_music_efectos(index, volume)
  stop_global_mp_efectos()

  local file_path = get_file_path(files_efectos[index])
  if file_path == nil then
    print("Archivo no encontrado: " .. files_efectos[index])
    return
  end
  
  local mp_efectos = MediaPlayer()
  mp_efectos.setDataSource(file_path)
  mp_efectos.setVolume(volume, volume)
  mp_efectos.prepare()
  mp_efectos.start()
  
  mp_efectos.setOnCompletionListener(MediaPlayer.OnCompletionListener {
    onCompletion = function()
      mp_efectos.release()
      global_mp_efectos = nil
    end
  })
  
  global_mp_efectos = mp_efectos
end
play_music_efectos(1, 1.0)
if RFirst then
RFirst = 1;
else
RFirst = 2;
end
if RFirst == 2 then
RCount = 1;
end
if RFirst == 1 then
RCount = RCount+1;
end
if RCount > 2 then
RCount = 1
end
switch RCount 
case 1
require "import"
import "android.content.Context"
import "android.os.Vibrator"
import "java.io.FileOutputStream"
import "java.io.OutputStreamWriter"
import "java.io.BufferedReader"
import "java.io.InputStreamReader"
import "android.media.MediaRecorder"
import "android.media.MediaScannerConnection"
import "java.io.File"
import "java.io.FileInputStream"
import "java.text.SimpleDateFormat"
import "java.util.Date"
import "android.content.ContentValues"
import "android.provider.MediaStore"
local folderPath = "/storage/emulated/0/Grabación con Plugin"
local folder = File(folderPath)

if not folder.exists() then
  local success = folder.mkdirs()

  if success then
    service.asyncSpeak("creado por sergio pina: " .. folderPath)
  else
    service.asyncSpeak("No se pudo crear la carpeta en: " .. folderPath)
  end
end


counterFile = File("/storage/emulated/0/orden.txt")
counterFile.delete()
local isRecording = false
local folderName = "Grabación con Plugin"
local folderPath = "/storage/emulated/0/" .. folderName
local counterFilePath = "/storage/emulated/0/contador.txt"
local dateFormat = SimpleDateFormat("HH_mm_ss", Locale.getDefault())
local currentTime = dateFormat.format(Date())
--marcador 1
local outputFile = folderPath .. "/recorded_audio_" .. currentTime .. ".m4a"

local function createCounterFile()
    local file = File(counterFilePath)
    if not file.exists() then
        file.createNewFile()
        local outputStream = FileOutputStream(file)
        local writer = OutputStreamWriter(outputStream)
        writer.write("1")
        writer.close()
        outputStream.close()
    end
end

local function readFileContent(file)
    local content = ""
    local bufferedReader = BufferedReader(InputStreamReader(FileInputStream(file)))
    local line = bufferedReader.readLine()
    while line do
        content = content .. line
        line = bufferedReader.readLine()
    end
    bufferedReader.close()
    return content
end

local function getCounter()
    createCounterFile()
    local file = File(counterFilePath)
    local content = readFileContent(file)
    local counter = tonumber(content)
    return counter
end

local function updateCounter(counter)
    local file = File(counterFilePath)
    local outputStream = FileOutputStream(file)
    local writer = OutputStreamWriter(outputStream)
    writer.write(tostring(counter))
    writer.close()
    outputStream.close()
end

local function getNextRecordingNumber()
    local counter = getCounter()
    updateCounter(counter + 1)
    return counter
end

--marcador
function stopRecording()
    if isRecording then
        mediaRecorder.stop()
        mediaRecorder.release()
        mediaRecorder = nil
        isRecording = false

        -- Escaneo del archivo para que aparezca en la galería de medios
        MediaScannerConnection.scanFile(this, {outputFile}, nil, nil)

        local values = ContentValues()
        values.put(MediaStore.MediaColumns.DATA, outputFile)
        values.put(MediaStore.MediaColumns.TITLE, "Grabación de audio")
values.put(MediaStore.MediaColumns.MIME_TYPE, "audio/mp4")
        this.getContentResolver().insert(MediaStore.Audio.Media.EXTERNAL_CONTENT_URI, values)
    end
end

function startRecording()
    if not isRecording then
        mediaRecorder = MediaRecorder()
        mediaRecorder.setAudioSource(MediaRecorder.AudioSource.MIC)
mediaRecorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4)
mediaRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AAC)

        mediaRecorder.setAudioEncodingBitRate(320000)
        mediaRecorder.setAudioSamplingRate(48000)
        mediaRecorder.setAudioChannels(2)  -- 2 canales para estéreo
local recordingNumber = getNextRecordingNumber()
--marcador 3
local recordingFile = File(folderPath, "grabacion_" .. recordingNumber .. ".m4a")
outputFile = recordingFile.getAbsolutePath()
mediaRecorder.setOutputFile(outputFile)
mediaRecorder.prepare()
mediaRecorder.start()
isRecording = true
end
end
startRecording()
local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
if vibrator.hasVibrator() then
    vibrator.vibrate(100)
end
return true

case 2
stopRecording()
play_music_efectos(2, 1.0)
require "import"
import "android.content.Context"
import "android.os.Vibrator"
local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
if vibrator.hasVibrator() then
    vibrator.vibrate(200)
end
return true
end
return true
